#
#		Python GUI - Utilities - PyObjC
#

from inspect import getmro

def NSMultiClass(name, bases, dic):
    #  Workaround for PyObjC classes not supporting
    #  multiple inheritance properly. Note: MRO is
    #  right to left across the bases.
    main = bases[0]
    slots = list(dic.get('__slots__', ()))
    dic2 = {}
    for mix in bases[1:]:
        for cls in getmro(mix)[::-1]:
            slots2 = cls.__dict__.get('__slots__')
            if slots2:
                for slot in slots2:
                    if slot not in slots:
                        slots.append(slot)
            dic2.update(cls.__dict__)
    dic2.update(dic)
    if slots:
        dic2['__slots__'] = slots
    cls = type(main)(name, (main,), dic2)
    return cls
